#include <windows.h>

#include "resource.h"
#include <sys/stat.h>
#include <io.h>


#include <string>
using namespace std;


#define EnableDlgItem(d,x,e) EnableWindow(GetDlgItem((d),(x)),(e))

extern "C" int filecopy (char *inpfn, char *outfn,int cols	);
//int is_sf2(char *infilename);

/****************************************************************************
* 
*    FUNCTION: LoadFile()
*
*    PURPOSE:  Lets the user go select a file.
*
****************************************************************************/
int LoadFile( HWND hWnd,char *dirpath,int &numfilenames,char **filename)
{
OPENFILENAME	LoadFileName;
char			szFile[MAX_PATH*256] = "";
char *myfilename;
int filenamecount=0;

		LoadFileName.lStructSize       = sizeof (LoadFileName);
		LoadFileName.hwndOwner         = hWnd;
		LoadFileName.lpstrFilter       = "Text File (*.txt)\0*.txt\0";
		LoadFileName.lpstrCustomFilter = (LPTSTR)NULL;
		LoadFileName.nMaxCustFilter    = 0L;
		LoadFileName.nFilterIndex      = 1L;
		LoadFileName.lpstrFile         = szFile;
		LoadFileName.nMaxFile          = MAX_PATH*256;
		LoadFileName.lpstrFileTitle    = NULL;
		LoadFileName.nMaxFileTitle     = 0;
		LoadFileName.lpstrInitialDir   = dirpath;
		LoadFileName.lpstrTitle        = "Load Text file(s)...";
		LoadFileName.nFileOffset       = 0;
		LoadFileName.nFileExtension    = 0;
		LoadFileName.lpstrDefExt       = "*.*";
		LoadFileName.lpfnHook		   = NULL;
 		LoadFileName.Flags = OFN_LONGNAMES
							//Very important flag - it says we want to keep the output/working folder to the program folder - NOT the one selected by the user here
							|OFN_NOCHANGEDIR
							|OFN_FILEMUSTEXIST
							|OFN_EXPLORER;

		if( !GetOpenFileName (&LoadFileName)) 
			return(1);

		strcpy (dirpath,szFile);
//		SendDlgItemMessage (hWnd, IDC_EDITHOMEDIR, WM_SETTEXT, (WPARAM) MAX_PATH, (LPARAM) dirpath);

	    myfilename=szFile;
		myfilename+=strlen(myfilename)+1;

	    while(*myfilename)
		{
			filename[filenamecount] = (char *) malloc (MAX_PATH * sizeof(char));
			strcpy(filename[filenamecount], myfilename);
			myfilename += strlen(myfilename) + 1;
			filenamecount++;
	    }
		numfilenames = filenamecount;

		if (numfilenames==0)
		{
			filename[0] = (char *) malloc (MAX_PATH * sizeof(char));
			strcpy (filename[0], szFile);
			dirpath[strrchr (dirpath, '\\') - dirpath] = '\0';
			numfilenames = 1;
		}
	return (0);
}

LRESULT CALLBACK MainDialogProc(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	static char		dirpath[MAX_PATH];
	static char		*filename[4096];
	static int		numfilenames;
	static int		donefilenames=0;

	switch (message)
	{
		case WM_CLOSE:
		{
			EndDialog(hDlg, LOWORD(wParam));
			break;
		}

		case WM_INITDIALOG:
		{
//			SetWindowIcons(ghDlg, IDI_MAILSCOURLOGOBIG,IDI_MAILSCOURLOGOSMALL);
			ShowWindow(hDlg,SW_RESTORE);
			SendDlgItemMessage (hDlg, IDC_EDITCOLS, WM_SETTEXT, (WPARAM) 3, (LPARAM) "65");
			break;
		}
		case WM_COMMAND:
		{
			if (LOWORD(wParam) == IDCANCEL)
			{
				EndDialog(hDlg, LOWORD(wParam));
				break;
			}

			if (LOWORD(wParam) == IDC_CHECK1)
			{
				int opt_avglines = SendDlgItemMessage(hDlg, IDC_CHECK1, BM_GETCHECK, 0, 0);
				if (opt_avglines == 1)
				{
					EnableDlgItem( hDlg, IDC_EDITCOLS, FALSE );
					SendDlgItemMessage (hDlg, IDC_EDITCOLS, WM_SETTEXT, (WPARAM) MAX_PATH, (LPARAM) "-1");
				}
				else
				{
					EnableDlgItem( hDlg, IDC_EDITCOLS, TRUE );
					SendDlgItemMessage (hDlg, IDC_EDITCOLS, WM_SETTEXT, (WPARAM) MAX_PATH, (LPARAM) "65");
				}
			}

			if (LOWORD(wParam) == IDOK)
			{
				char temp[2049];
				char temp2[2049];
				char tempcols[2049];
				SendDlgItemMessage (hDlg, IDC_EDITFILENAME, WM_GETTEXT, (WPARAM)2048,(LPARAM) temp);
				SendDlgItemMessage(hDlg, IDC_EDITOUTFILE, WM_GETTEXT, (WPARAM)2048,(LPARAM)temp2);
				SendDlgItemMessage (hDlg, IDC_EDITCOLS, WM_GETTEXT, (WPARAM)2048,(LPARAM) tempcols);

				int opt_avglines = SendDlgItemMessage(hDlg, IDC_CHECK1, BM_GETCHECK, 0, 0);
				long avglines = atol(tempcols);

				if (opt_avglines == 1)
				{
					avglines = -1;	
				}
				else
				{
					avglines = atol(tempcols);
				}
	
				char number[100];
				sprintf(number,"%ld",avglines);

				SendDlgItemMessage (hDlg, IDC_EDITCOLS, WM_SETTEXT, (WPARAM) MAX_PATH, (LPARAM) number);

				int result = filecopy(temp,temp2,avglines);

				if (result == 0)
				{
					MessageBox(hDlg,"Text file aligned successfully","Success",NULL);
				}
				else
					MessageBox(hDlg,"Alignment failed","Failed",NULL);
				return 1;
			}

			if (LOWORD(wParam) == IDC_BROWSE)
			{
				static char		*filename[4096];
				static int		numfilenames;
				static char		dirpath[MAX_PATH];
				strcpy(dirpath,"");

				if (LoadFile (hDlg, dirpath, numfilenames, filename) == 1)
				{
					return 1;
				}

				//returns 0 on success
//				if (!is_sf2(filename[0]))
				{
					//Returns 0 - success
					SendDlgItemMessage(hDlg, IDC_EDITFILENAME, WM_SETTEXT, (WPARAM)512,(LPARAM)filename[0]);

					string chopper = filename[0];
					chopper.erase(chopper.rfind('.'),chopper.length());
//					CreateDirectory(chopper.c_str(),NULL);
					chopper.append(".ncr.txt");
					SendDlgItemMessage(hDlg, IDC_EDITOUTFILE, WM_SETTEXT, (WPARAM)512,(LPARAM)(char *)chopper.c_str());
					donefilenames = 1;
				}
//				else
//				{
//					MessageBox(hDlg,"File selected is not a valid Soundfont 2 file","Failed",NULL);
//				}
				return 1;
			}

		}

	}
	return FALSE;
}


string dialog(HINSTANCE hInstance)
{
	DialogBox(hInstance,(LPCTSTR)IDD_DIALOG1,NULL, (DLGPROC)MainDialogProc);
	return "";
}

//void main(int argc,char **argv)
int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
              int       nCmdShow)
{
	string cmd = GetCommandLine();
	string filename = dialog(hInstance);

	return 0;//1
}

bool file_exists(string filename)
{
    if ( access( filename.c_str(), 0 ) == 0 )
    {
		return true;
	}
	else
		return false;
}

int main(int argc, char *argv[])
{
	printf("Form byebyecr <input filename> <output filename> <average number of columns (-1 means guess)>\n");
	printf("Eg... 'byebyecr JaneEyre.txt JaneEyreFormatted.txt 60'\n\n");

	if (argc == 4)
	{
		if (file_exists(argv[1]))
		{
			int result = filecopy(argv[1],argv[2],atol(argv[3]));
			if (result == 0)
			{
				printf("Conversion was successful\n");
			}
			else
			{
				printf("Conversion was not successful\n");
			}
			return result;
		}
		else
		{
			printf("File does not exist\n");
		}
	}
	else
	{
		printf("byebyecr Expects 3 arguments\n");
	}
	
	return 1;
}

